//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;

namespace LOC
{
	/// <summary>
	/// Podsumowanie dla Class1.
	/// </summary>
	class LargeObjectTest
	{
		/// <summary>
		/// Główny punkt wejścia dla aplikacji.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów przed alokacją: {0}", GC.GetTotalMemory(false));
			LargeObject lo = new LargeObject();
			Console.WriteLine("Całkowita liczba bajtów: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Obiekt generacji {0}", GC.GetGeneration(lo));
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Obiekt generacji {0}", GC.GetGeneration(lo));
			Console.WriteLine("Dealokacja obiektu");
			lo = null;
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));

			Console.WriteLine("----------- Ponownie -----------");

			Console.WriteLine("Całkowita liczba bajtów przed alokacją: {0}", GC.GetTotalMemory(false));
			LargeObject lo = new LargeObject();
			Console.WriteLine("Całkowita liczba bajtów: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Obiekt generacji {0}", GC.GetGeneration(lo));
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Obiekt generacji {0}", GC.GetGeneration(lo));
			Console.WriteLine("Dealokacja obiektu");
			lo = null;
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));
			Console.WriteLine("Oczyszczanie");
			GC.Collect();
			Console.WriteLine("Całkowita liczba bajtów po oczyszczaniu: {0}", GC.GetTotalMemory(false));
		}
	}
}
